[LeetCode] 975. Odd Even Jump_Hard tag: stack, dynamic programming
作者:互联网
You are given an integer array arr
. From some starting index, you can make a series of jumps. The (1st, 3rd, 5th, ...) jumps in the series are called odd-numbered jumps, and the (2nd, 4th, 6th, ...) jumps in the series are called even-numbered jumps. Note that the jumps are numbered, not the indices.
You may jump forward from index i
to index j
(with i < j
) in the following way:
- During odd-numbered jumps (i.e., jumps 1, 3, 5, ...), you jump to the index
j
such thatarr[i] <= arr[j]
andarr[j]
is the smallest possible value. If there are multiple such indicesj
, you can only jump to the smallest such indexj
. - During even-numbered jumps (i.e., jumps 2, 4, 6, ...), you jump to the index
j
such thatarr[i] >= arr[j]
andarr[j]
is the largest possible value. If there are multiple such indicesj
, you can only jump to the smallest such indexj
. - It may be the case that for some index
i
, there are no legal jumps.
A starting index is good if, starting from that index, you can reach the end of the array (index arr.length - 1
) by jumping some number of times (possibly 0 or more than once).
Return the number of good starting indices.
Example 1:
Input: arr = [10,13,12,14,15] Output: 2 Explanation: From starting index i = 0, we can make our 1st jump to i = 2 (since arr[2] is the smallest among arr[1], arr[2], arr[3], arr[4] that is greater or equal to arr[0]), then we cannot jump any more. From starting index i = 1 and i = 2, we can make our 1st jump to i = 3, then we cannot jump any more. From starting index i = 3, we can make our 1st jump to i = 4, so we have reached the end. From starting index i = 4, we have reached the end already. In total, there are 2 different starting indices i = 3 and i = 4, where we can reach the end with some number of jumps.
Example 2:
Input: arr = [2,3,1,1,4] Output: 3 Explanation: From starting index i = 0, we make jumps to i = 1, i = 2, i = 3: During our 1st jump (odd-numbered), we first jump to i = 1 because arr[1] is the smallest value in [arr[1], arr[2], arr[3], arr[4]] that is greater than or equal to arr[0]. During our 2nd jump (even-numbered), we jump from i = 1 to i = 2 because arr[2] is the largest value in [arr[2], arr[3], arr[4]] that is less than or equal to arr[1]. arr[3] is also the largest value, but 2 is a smaller index, so we can only jump to i = 2 and not i = 3 During our 3rd jump (odd-numbered), we jump from i = 2 to i = 3 because arr[3] is the smallest value in [arr[3], arr[4]] that is greater than or equal to arr[2]. We can't jump from i = 3 to i = 4, so the starting index i = 0 is not good. In a similar manner, we can deduce that: From starting index i = 1, we jump to i = 4, so we reach the end. From starting index i = 2, we jump to i = 3, and then we can't jump anymore. From starting index i = 3, we jump to i = 4, so we reach the end. From starting index i = 4, we are already at the end. In total, there are 3 different starting indices i = 1, i = 3, and i = 4, where we can reach the end with some number of jumps.
Example 3:
Input: arr = [5,1,3,4,2] Output: 3 Explanation: We can reach the end from starting indices 1, 2, and 4.
Constraints:
1 <= arr.length <= 2 * 104
0 <= arr[i] < 105
Ideas:
题目意思是,第一次(奇数跳的时候)跳要找大的higher,第二次(偶数跳)跳要找小的lower,然后交替进行;
1. 对于奇数跳, 我们要找这个index之后的最小值可以大于等于这个index的数
2. 对于偶数跳,我们要找这个index之后的最大值可以小于等于这个index的数(# dont use sorted(..., reverse = True) because we want the first index if there is a tie)
note: 因为不是离index最近的最小或者最大,所以单纯monotonic stack 不行,因为是最小或者最大,所以需要sort以下,然后再用类似于monotonic stack的方式来得到next_lower和next_higher
3. 利用dynamic programming,从后往前推
4. function: higher[index] = lower[next_higher[index]]
lower[index] = higher[next_lower[index]]
因为跳跃是higher(odd),lower(even)交替进行
5. 最后返回sum(higher) 因为我们从odd跳开始,也就是说最开始要找higher
Code:
class Solution: def oddEvenJumps(self, arr: List[int]) -> int: next_higher = self.makeStack(sorted([(num, index) for index, num in enumerate(arr)])) next_lower = self.makeStack(sorted([(-num, index) for index, num in enumerate(arr)])) # dont use sorted(..., reverse = True) because we want the first index if there is a tie n = len(arr) higher, lower = [False] * n, [False] * n # higher means odd, lower means even higher[-1], lower[-1] = True, True for i in range(n - 1, -1, -1): if next_higher[i] is not None: higher[i] = lower[next_higher[i]] if next_lower[i] is not None: lower[i] = higher[next_lower[i]] return sum(higher) def makeStack(self, s_indexes): res = [None] * (len(s_indexes)) stack = [] for _, index in s_indexes: while stack and index > stack[-1]: res[stack.pop()] = index stack.append(index) return res
标签:Even,index,975,jumps,programming,arr,jump,starting,higher 来源: https://www.cnblogs.com/Johnsonxiong/p/15097856.html